%%% -*- TeX-command-extra-options: "-shell-escape" -*-
%%% Local IspellDict: en

% A visualization of vector timestamps
% Copyright (C) 2018 Jens Lechtenbörger
% License: CC BY-SA 4.0

\documentclass[convert={outext=.png}]{standalone}
% Use sans-serif by default:
% \renewcommand{\familydefault}{\sfdefault}
\usepackage{amsmath}
\usepackage{tikz}
\usetikzlibrary{arrows.meta,positioning}

\newcommand\vclock[3]{$\tiny\begin{pmatrix}#1\\#2\\#3\end{pmatrix}$}
\begin{document}

\begin{tikzpicture}[
  process/.style={},
  event/.style={
         circle,
         fill=black,
         inner sep=2pt,
         minimum size=0.2cm}
  ]
  \draw[->,thick] (0,0.5) -- (9,0.5) node [pos=0.95,above] {time};

  \node (p1) at (0,2) [process%,label=below:\vclock{0}{0}{0}
     ] {P1};
  \draw[-] (0.5,2) -- (9,2);
  \node (e11) at (0.8,2) [event,label=above:$e_{11}$,label=below:\vclock{0}{0}{1}]{};
  \node (e12) at (1.6,2) [event,label=above:$e_{12}$,label=below:\vclock{0}{0}{2}]{};
  \node (e13) at (2.4,2) [event,label=above:$e_{13}$,label=below:\vclock{0}{0}{3}]{};
   \node (e14) at (4,2) [event,label=above:$e_{14}$,label=below:\vclock{0}{0}{4}]{};
  \node (e15) at (5,2) [event,label=above:$e_{15}$,label=below:\vclock{0}{3}{5}]{};
  \node (e16) at (7,2) [event,label=above:$e_{16}$,label=below:\vclock{0}{3}{6}]{};

  \node (p2) at (0,4) [process%,label=below:\vclock{0}{0}{0}
     ] {P2};
  \draw[-] (0.5,4) -- (9,4);
  \node (e21) at (0.5,4) [event,label=above:$e_{21}$,label=below:\vclock{0}{1}{0}]{};
  \node (e22) at (1.5,4) [event,label=above:$e_{22}$,label=below:\vclock{0}{2}{0}]{};
  \node (e23) at (4,4) [event,label=above:$e_{23}$,label=below:\vclock{0}{3}{0}]{};
  \node (e24) at (5.5,4) [event,label=above:$e_{24}$,label=below:\vclock{0}{4}{0}]{};
  \node (e25) at (7,4) [event,label=above:$e_{25}$,label=below:\vclock{0}{5}{0}]{};

  \node (p3) at (0,6) [process%,label=below:\vclock{0}{0}{0}
     ] {P3};
  \draw[-] (0.5,6) -- (9,6);
  \node (e31) at (5,6) [event,label=above:$e_{31}$,label=below:\vclock{1}{0}{2}]{};
  \node (e32) at (8,6) [event,label=above:$e_{32}$,label=below:\vclock{2}{2}{2}]{};

  \draw[->] (e12) -- (e31);
  \draw[->] (e23) -- (e15);
  \draw[->] (e22) -- (e32);

\end{tikzpicture}
\end{document}
